/*
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.18
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.UpbitOpenApi) {
      root.UpbitOpenApi = {};
    }
    root.UpbitOpenApi.MemberLevel = factory(root.UpbitOpenApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The MemberLevel model module.
   * @module model/MemberLevel
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>MemberLevel</code>.
   * 사용자의 보안등급 정보
   * @alias module:model/MemberLevel
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>MemberLevel</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/MemberLevel} obj Optional instance to populate.
   * @return {module:model/MemberLevel} The populated <code>MemberLevel</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('security_level'))
        obj.securityLevel = ApiClient.convertToType(data['security_level'], 'Number');
      if (data.hasOwnProperty('fee_level'))
        obj.feeLevel = ApiClient.convertToType(data['fee_level'], 'Number');
      if (data.hasOwnProperty('email_verified'))
        obj.emailVerified = ApiClient.convertToType(data['email_verified'], 'Boolean');
      if (data.hasOwnProperty('identity_auth_verified'))
        obj.identityAuthVerified = ApiClient.convertToType(data['identity_auth_verified'], 'Boolean');
      if (data.hasOwnProperty('bank_account_verified'))
        obj.bankAccountVerified = ApiClient.convertToType(data['bank_account_verified'], 'Boolean');
      if (data.hasOwnProperty('kakao_pay_auth_verified'))
        obj.kakaoPayAuthVerified = ApiClient.convertToType(data['kakao_pay_auth_verified'], 'Boolean');
      if (data.hasOwnProperty('locked'))
        obj.locked = ApiClient.convertToType(data['locked'], 'Boolean');
      if (data.hasOwnProperty('wallet_locked'))
        obj.walletLocked = ApiClient.convertToType(data['wallet_locked'], 'Boolean');
    }
    return obj;
  }

  /**
   * 사용자의 보안 등급
   * @member {Number} securityLevel
   */
  exports.prototype.securityLevel = undefined;

  /**
   * 사용자의 수수료 등급
   * @member {Number} feeLevel
   */
  exports.prototype.feeLevel = undefined;

  /**
   * 사용자의 이메일 인증 여부
   * @member {Boolean} emailVerified
   */
  exports.prototype.emailVerified = undefined;

  /**
   * 사용자의 실명 인증 여부
   * @member {Boolean} identityAuthVerified
   */
  exports.prototype.identityAuthVerified = undefined;

  /**
   * 사용자의 계좌 인증 여부
   * @member {Boolean} bankAccountVerified
   */
  exports.prototype.bankAccountVerified = undefined;

  /**
   * 사용자의 카카오페이 인증 여부
   * @member {Boolean} kakaoPayAuthVerified
   */
  exports.prototype.kakaoPayAuthVerified = undefined;

  /**
   * 사용자의 계정 보호 상태
   * @member {Boolean} locked
   */
  exports.prototype.locked = undefined;

  /**
   * 사용자의 출금 보호 상태
   * @member {Boolean} walletLocked
   */
  exports.prototype.walletLocked = undefined;


  return exports;

}));
